// hardly taken from urlfix ;-=--)

function getNumPairs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("urlcorrector.");
	return prefs.getIntPref("numPairs");
}

function loadRecodePair(idx)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("urlcorrector.");
	//getLocalizedPreferenceString(prefs, "numPairs", idx+1);
	outArr = new Array();
	outArr.strName = getLocalizedPreferenceString(prefs, "pair_"+idx+"_name");
	outArr.checked = prefs.getBoolPref("pair_"+idx+"_checked");

	outArr.strFrom = getLocalizedPreferenceString(prefs, "pair_"+idx+"_from");
	outArr.strTo = getLocalizedPreferenceString(prefs, "pair_"+idx+"_to");
	
	return outArr;
}

function saveRecodePair(idx, strName, checked, strFrom, strTo)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("urlcorrector.");
	prefs.setIntPref("numPairs", idx+1);
	setLocalizedPreferenceString(prefs, "pair_"+idx+"_name", strName);
	prefs.setBoolPref("pair_"+idx+"_checked", checked);

	setLocalizedPreferenceString(prefs, "pair_"+idx+"_from", strFrom);
	setLocalizedPreferenceString(prefs, "pair_"+idx+"_to", strTo);
}

function loadDefaults()
{
	var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	var ds = RDF.GetDataSourceBlocking('chrome://urlcorrector/content/defaults.rdf');
	
	var rootSubject = RDF.GetResource('urn:root');
	var numPairs = ds.GetTarget(rootSubject, RDF.GetResource('http://urlcorrector.mozdev.org/rdf#numPairs'), true)
					.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
					
	for (var x=0; x<numPairs; x++)
	{
		var strName = ds.GetTarget(rootSubject, RDF.GetResource('http://urlcorrector.mozdev.org/rdf#pair_'+x+'_name'), true)
					.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		var strFrom = ds.GetTarget(rootSubject, RDF.GetResource('http://urlcorrector.mozdev.org/rdf#pair_'+x+'_from'), true)
					.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		var strTo = ds.GetTarget(rootSubject, RDF.GetResource('http://urlcorrector.mozdev.org/rdf#pair_'+x+'_to'), true)
					.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		var checked = ds.GetTarget(rootSubject, RDF.GetResource('http://urlcorrector.mozdev.org/rdf#pair_'+x+'_checked'), true)
					.QueryInterface(Components.interfaces.nsIRDFLiteral).Value == "true"; //tbf
		saveRecodePair(x, strName, checked, strFrom, strTo);
		
	}
}

// Dealing with international strings (taken from Googlebar)
function getLocalizedPreferenceString(prefBranch, key)
{
	var value = prefBranch.getComplexValue(key, Components.interfaces.nsISupportsWString ||
            Components.interfaces.nsISupportsString).data;

	return value;
}

function setLocalizedPreferenceString(prefBranch, key, value)
{
    var localizedStringInterface =
			Components.interfaces.nsISupportsWString || Components.interfaces.nsISupportsString;

	var string = (Components.classes['@mozilla.org/supports-wstring;1'])
						?
						Components.classes['@mozilla.org/supports-wstring;1'].createInstance(localizedStringInterface)
						:
						Components.classes['@mozilla.org/supports-string;1'].createInstance(localizedStringInterface);

	string.data = value;
	prefBranch.setComplexValue(key, localizedStringInterface, string);
}


// utility

function urlCorrectDumpObject(obj){
	for(var i in obj){
		dump(i + " = " + obj[i] + "\n\r");
	}
	
}
