var gURLBar = null;
var oldKeyPress = null;

var needsRecode = 0;

var presets = new Array();

function logToCons(textToLog)
{
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                               .getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage(textToLog);
}

function loadTables()
{
	presets.splice(0, presets.length);
	
	var numPairs = 0;
	try
	{
		numPairs = getNumPairs();
	}
	catch(e)
	{
		loadDefaults();
		numPairs = getNumPairs();
	}

	for (var x=0; x<numPairs; x++)
	{
		var outArr = loadRecodePair(x);

		if (outArr.checked)		
			presets.push(outArr);
	}
}

function urlCorrectInsertText(aText) {
	try {
	var command = "cmd_insertText";
	var controller = document.commandDispatcher.getControllerForCommand(command);
	if (controller && controller.isCommandEnabled(command)) {
		controller = controller.QueryInterface(Components.interfaces.nsICommandController);
		var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
		params = params.createInstance(Components.interfaces.nsICommandParams);
		params.setStringValue("state_data", aText);
		controller.doCommandWithParams(command, params);
	}
	}
	catch (e) {
	dump("Can't do cmd_insertText! ");
	dump(e+"\n")
	}
}

function urlCorrectReplace(ch)
{
	//if (ch <= 126 && needsRecode == 0) // skip recoding of points and slashes if it's not in non-english mode
	//	return null;
	if (!presets.length)
		loadTables();
	for (var x=0; x<presets.length; x++)
	{
		var pos = presets[x].strFrom.indexOf(String.fromCharCode(ch));
		if (pos != -1)
		{
			return presets[x].strTo.charAt(pos);
		}
	}


	return null;
}

function urlCorrectDoIt(event)	
{
	var ch = urlCorrectReplace(event.which);
	if (ch != null)
	{
		needsRecode = 1;
		event.preventDefault();

		urlCorrectInsertText(ch);

	}
	else
		needsRecode = !(event.which>=32 && event.which<=126); // normal chars are typed
		
}

function urlCorrectInit()
{
	var appcontent = document.getElementById("appcontent");   // browser
	if(appcontent)
	{
		appcontent.addEventListener("load", urlCorrectInit, true);
		appcontent.addEventListener("focus", loadTables, false);
	}


	gURLBar = document.getElementById("urlbar"); 
	if (gURLBar != null)
	{
		gURLBar.addEventListener("keypress", urlCorrectDoIt, false);
		//tbf: works not
		gURLBar.addEventListener("focus", loadTables, false);
	}
	else
		dump("URLCorrector.\rInitialization failed. Object 'urlbar' not found.");

}

window.addEventListener('load', urlCorrectInit, true);
